// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from ds_dbw_msgs:msg/BrakeReport.idl
// generated code does not contain a copyright notice
#include "ds_dbw_msgs/msg/detail/brake_report__rosidl_typesupport_fastrtps_cpp.hpp"
#include "ds_dbw_msgs/msg/detail/brake_report__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace std_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const std_msgs::msg::Header &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  std_msgs::msg::Header &);
size_t get_serialized_size(
  const std_msgs::msg::Header &,
  size_t current_alignment);
size_t
max_serialized_size_Header(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace std_msgs

namespace ds_dbw_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const ds_dbw_msgs::msg::CmdSrc &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  ds_dbw_msgs::msg::CmdSrc &);
size_t get_serialized_size(
  const ds_dbw_msgs::msg::CmdSrc &,
  size_t current_alignment);
size_t
max_serialized_size_CmdSrc(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace ds_dbw_msgs


namespace ds_dbw_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
cdr_serialize(
  const ds_dbw_msgs::msg::BrakeReport & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.header,
    cdr);
  // Member: cmd_type
  cdr << ros_message.cmd_type;
  // Member: pressure_input
  cdr << ros_message.pressure_input;
  // Member: pressure_cmd
  cdr << ros_message.pressure_cmd;
  // Member: pressure_output
  cdr << ros_message.pressure_output;
  // Member: torque_input
  cdr << ros_message.torque_input;
  // Member: torque_cmd
  cdr << ros_message.torque_cmd;
  // Member: torque_output
  cdr << ros_message.torque_output;
  // Member: accel_cmd
  cdr << ros_message.accel_cmd;
  // Member: accel_output
  cdr << ros_message.accel_output;
  // Member: percent_input
  cdr << ros_message.percent_input;
  // Member: percent_cmd
  cdr << ros_message.percent_cmd;
  // Member: percent_output
  cdr << ros_message.percent_output;
  // Member: btsi_cmd
  cdr << (ros_message.btsi_cmd ? true : false);
  // Member: limiting_value
  cdr << (ros_message.limiting_value ? true : false);
  // Member: limiting_rate
  cdr << (ros_message.limiting_rate ? true : false);
  // Member: external_control
  cdr << (ros_message.external_control ? true : false);
  // Member: ready
  cdr << (ros_message.ready ? true : false);
  // Member: enabled
  cdr << (ros_message.enabled ? true : false);
  // Member: override_active
  cdr << (ros_message.override_active ? true : false);
  // Member: override_other
  cdr << (ros_message.override_other ? true : false);
  // Member: override_latched
  cdr << (ros_message.override_latched ? true : false);
  // Member: timeout
  cdr << (ros_message.timeout ? true : false);
  // Member: fault
  cdr << (ros_message.fault ? true : false);
  // Member: bad_crc
  cdr << (ros_message.bad_crc ? true : false);
  // Member: bad_rc
  cdr << (ros_message.bad_rc ? true : false);
  // Member: degraded
  cdr << (ros_message.degraded ? true : false);
  // Member: limit_value
  cdr << ros_message.limit_value;
  // Member: brake_available_duration
  cdr << ros_message.brake_available_duration;
  // Member: brake_available_full
  cdr << (ros_message.brake_available_full ? true : false);
  // Member: req_shift_park
  cdr << (ros_message.req_shift_park ? true : false);
  // Member: req_park_brake
  cdr << (ros_message.req_park_brake ? true : false);
  // Member: external_button
  cdr << (ros_message.external_button ? true : false);
  // Member: cmd_src
  ds_dbw_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.cmd_src,
    cdr);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  ds_dbw_msgs::msg::BrakeReport & ros_message)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.header);

  // Member: cmd_type
  cdr >> ros_message.cmd_type;

  // Member: pressure_input
  cdr >> ros_message.pressure_input;

  // Member: pressure_cmd
  cdr >> ros_message.pressure_cmd;

  // Member: pressure_output
  cdr >> ros_message.pressure_output;

  // Member: torque_input
  cdr >> ros_message.torque_input;

  // Member: torque_cmd
  cdr >> ros_message.torque_cmd;

  // Member: torque_output
  cdr >> ros_message.torque_output;

  // Member: accel_cmd
  cdr >> ros_message.accel_cmd;

  // Member: accel_output
  cdr >> ros_message.accel_output;

  // Member: percent_input
  cdr >> ros_message.percent_input;

  // Member: percent_cmd
  cdr >> ros_message.percent_cmd;

  // Member: percent_output
  cdr >> ros_message.percent_output;

  // Member: btsi_cmd
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btsi_cmd = tmp ? true : false;
  }

  // Member: limiting_value
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.limiting_value = tmp ? true : false;
  }

  // Member: limiting_rate
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.limiting_rate = tmp ? true : false;
  }

  // Member: external_control
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.external_control = tmp ? true : false;
  }

  // Member: ready
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.ready = tmp ? true : false;
  }

  // Member: enabled
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.enabled = tmp ? true : false;
  }

  // Member: override_active
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.override_active = tmp ? true : false;
  }

  // Member: override_other
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.override_other = tmp ? true : false;
  }

  // Member: override_latched
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.override_latched = tmp ? true : false;
  }

  // Member: timeout
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.timeout = tmp ? true : false;
  }

  // Member: fault
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.fault = tmp ? true : false;
  }

  // Member: bad_crc
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.bad_crc = tmp ? true : false;
  }

  // Member: bad_rc
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.bad_rc = tmp ? true : false;
  }

  // Member: degraded
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.degraded = tmp ? true : false;
  }

  // Member: limit_value
  cdr >> ros_message.limit_value;

  // Member: brake_available_duration
  cdr >> ros_message.brake_available_duration;

  // Member: brake_available_full
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.brake_available_full = tmp ? true : false;
  }

  // Member: req_shift_park
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.req_shift_park = tmp ? true : false;
  }

  // Member: req_park_brake
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.req_park_brake = tmp ? true : false;
  }

  // Member: external_button
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.external_button = tmp ? true : false;
  }

  // Member: cmd_src
  ds_dbw_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.cmd_src);

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
get_serialized_size(
  const ds_dbw_msgs::msg::BrakeReport & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: header

  current_alignment +=
    std_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.header, current_alignment);
  // Member: cmd_type
  {
    size_t item_size = sizeof(ros_message.cmd_type);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: pressure_input
  {
    size_t item_size = sizeof(ros_message.pressure_input);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: pressure_cmd
  {
    size_t item_size = sizeof(ros_message.pressure_cmd);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: pressure_output
  {
    size_t item_size = sizeof(ros_message.pressure_output);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: torque_input
  {
    size_t item_size = sizeof(ros_message.torque_input);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: torque_cmd
  {
    size_t item_size = sizeof(ros_message.torque_cmd);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: torque_output
  {
    size_t item_size = sizeof(ros_message.torque_output);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: accel_cmd
  {
    size_t item_size = sizeof(ros_message.accel_cmd);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: accel_output
  {
    size_t item_size = sizeof(ros_message.accel_output);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: percent_input
  {
    size_t item_size = sizeof(ros_message.percent_input);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: percent_cmd
  {
    size_t item_size = sizeof(ros_message.percent_cmd);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: percent_output
  {
    size_t item_size = sizeof(ros_message.percent_output);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btsi_cmd
  {
    size_t item_size = sizeof(ros_message.btsi_cmd);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: limiting_value
  {
    size_t item_size = sizeof(ros_message.limiting_value);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: limiting_rate
  {
    size_t item_size = sizeof(ros_message.limiting_rate);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: external_control
  {
    size_t item_size = sizeof(ros_message.external_control);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: ready
  {
    size_t item_size = sizeof(ros_message.ready);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: enabled
  {
    size_t item_size = sizeof(ros_message.enabled);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: override_active
  {
    size_t item_size = sizeof(ros_message.override_active);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: override_other
  {
    size_t item_size = sizeof(ros_message.override_other);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: override_latched
  {
    size_t item_size = sizeof(ros_message.override_latched);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: timeout
  {
    size_t item_size = sizeof(ros_message.timeout);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: fault
  {
    size_t item_size = sizeof(ros_message.fault);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: bad_crc
  {
    size_t item_size = sizeof(ros_message.bad_crc);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: bad_rc
  {
    size_t item_size = sizeof(ros_message.bad_rc);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: degraded
  {
    size_t item_size = sizeof(ros_message.degraded);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: limit_value
  {
    size_t item_size = sizeof(ros_message.limit_value);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: brake_available_duration
  {
    size_t item_size = sizeof(ros_message.brake_available_duration);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: brake_available_full
  {
    size_t item_size = sizeof(ros_message.brake_available_full);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: req_shift_park
  {
    size_t item_size = sizeof(ros_message.req_shift_park);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: req_park_brake
  {
    size_t item_size = sizeof(ros_message.req_park_brake);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: external_button
  {
    size_t item_size = sizeof(ros_message.external_button);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: cmd_src

  current_alignment +=
    ds_dbw_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.cmd_src, current_alignment);

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
max_serialized_size_BrakeReport(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: header
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        std_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Header(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: cmd_type
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: pressure_input
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: pressure_cmd
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: pressure_output
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: torque_input
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: torque_cmd
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: torque_output
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: accel_cmd
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: accel_output
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: percent_input
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: percent_cmd
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: percent_output
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: btsi_cmd
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: limiting_value
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: limiting_rate
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: external_control
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: ready
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: enabled
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: override_active
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: override_other
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: override_latched
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: timeout
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: fault
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: bad_crc
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: bad_rc
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: degraded
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: limit_value
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: brake_available_duration
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: brake_available_full
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: req_shift_park
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: req_park_brake
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: external_button
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: cmd_src
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        ds_dbw_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_CmdSrc(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = ds_dbw_msgs::msg::BrakeReport;
    is_plain =
      (
      offsetof(DataType, cmd_src) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _BrakeReport__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const ds_dbw_msgs::msg::BrakeReport *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _BrakeReport__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<ds_dbw_msgs::msg::BrakeReport *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _BrakeReport__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const ds_dbw_msgs::msg::BrakeReport *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _BrakeReport__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_BrakeReport(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _BrakeReport__callbacks = {
  "ds_dbw_msgs::msg",
  "BrakeReport",
  _BrakeReport__cdr_serialize,
  _BrakeReport__cdr_deserialize,
  _BrakeReport__get_serialized_size,
  _BrakeReport__max_serialized_size
};

static rosidl_message_type_support_t _BrakeReport__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_BrakeReport__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace ds_dbw_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_ds_dbw_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<ds_dbw_msgs::msg::BrakeReport>()
{
  return &ds_dbw_msgs::msg::typesupport_fastrtps_cpp::_BrakeReport__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, ds_dbw_msgs, msg, BrakeReport)() {
  return &ds_dbw_msgs::msg::typesupport_fastrtps_cpp::_BrakeReport__handle;
}

#ifdef __cplusplus
}
#endif
