// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from ds_dbw_msgs:msg/SystemReport.idl
// generated code does not contain a copyright notice
#include "ds_dbw_msgs/msg/detail/system_report__rosidl_typesupport_fastrtps_cpp.hpp"
#include "ds_dbw_msgs/msg/detail/system_report__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace std_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const std_msgs::msg::Header &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  std_msgs::msg::Header &);
size_t get_serialized_size(
  const std_msgs::msg::Header &,
  size_t current_alignment);
size_t
max_serialized_size_Header(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace std_msgs

namespace ds_dbw_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const ds_dbw_msgs::msg::SystemSyncMode &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  ds_dbw_msgs::msg::SystemSyncMode &);
size_t get_serialized_size(
  const ds_dbw_msgs::msg::SystemSyncMode &,
  size_t current_alignment);
size_t
max_serialized_size_SystemSyncMode(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace ds_dbw_msgs

namespace ds_dbw_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const ds_dbw_msgs::msg::SystemState &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  ds_dbw_msgs::msg::SystemState &);
size_t get_serialized_size(
  const ds_dbw_msgs::msg::SystemState &,
  size_t current_alignment);
size_t
max_serialized_size_SystemState(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace ds_dbw_msgs


namespace ds_dbw_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
cdr_serialize(
  const ds_dbw_msgs::msg::SystemReport & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.header,
    cdr);
  // Member: inhibit
  cdr << (ros_message.inhibit ? true : false);
  // Member: validate_cmd_crc_rc
  cdr << (ros_message.validate_cmd_crc_rc ? true : false);
  // Member: system_sync_mode
  ds_dbw_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.system_sync_mode,
    cdr);
  // Member: state
  ds_dbw_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.state,
    cdr);
  // Member: reason_disengage
  cdr << ros_message.reason_disengage;
  // Member: reason_not_ready
  cdr << ros_message.reason_not_ready;
  // Member: reason_disengage_str
  cdr << ros_message.reason_disengage_str;
  // Member: reason_not_ready_str
  cdr << ros_message.reason_not_ready_str;
  // Member: btn_enable
  cdr << (ros_message.btn_enable ? true : false);
  // Member: btn_disable
  cdr << (ros_message.btn_disable ? true : false);
  // Member: override
  cdr << (ros_message.override ? true : false);
  // Member: ready
  cdr << (ros_message.ready ? true : false);
  // Member: enabled
  cdr << (ros_message.enabled ? true : false);
  // Member: fault
  cdr << (ros_message.fault ? true : false);
  // Member: bad_crc
  cdr << (ros_message.bad_crc ? true : false);
  // Member: bad_rc
  cdr << (ros_message.bad_rc ? true : false);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  ds_dbw_msgs::msg::SystemReport & ros_message)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.header);

  // Member: inhibit
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.inhibit = tmp ? true : false;
  }

  // Member: validate_cmd_crc_rc
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.validate_cmd_crc_rc = tmp ? true : false;
  }

  // Member: system_sync_mode
  ds_dbw_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.system_sync_mode);

  // Member: state
  ds_dbw_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.state);

  // Member: reason_disengage
  cdr >> ros_message.reason_disengage;

  // Member: reason_not_ready
  cdr >> ros_message.reason_not_ready;

  // Member: reason_disengage_str
  cdr >> ros_message.reason_disengage_str;

  // Member: reason_not_ready_str
  cdr >> ros_message.reason_not_ready_str;

  // Member: btn_enable
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_enable = tmp ? true : false;
  }

  // Member: btn_disable
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.btn_disable = tmp ? true : false;
  }

  // Member: override
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.override = tmp ? true : false;
  }

  // Member: ready
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.ready = tmp ? true : false;
  }

  // Member: enabled
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.enabled = tmp ? true : false;
  }

  // Member: fault
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.fault = tmp ? true : false;
  }

  // Member: bad_crc
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.bad_crc = tmp ? true : false;
  }

  // Member: bad_rc
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.bad_rc = tmp ? true : false;
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
get_serialized_size(
  const ds_dbw_msgs::msg::SystemReport & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: header

  current_alignment +=
    std_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.header, current_alignment);
  // Member: inhibit
  {
    size_t item_size = sizeof(ros_message.inhibit);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: validate_cmd_crc_rc
  {
    size_t item_size = sizeof(ros_message.validate_cmd_crc_rc);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: system_sync_mode

  current_alignment +=
    ds_dbw_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.system_sync_mode, current_alignment);
  // Member: state

  current_alignment +=
    ds_dbw_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.state, current_alignment);
  // Member: reason_disengage
  {
    size_t item_size = sizeof(ros_message.reason_disengage);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: reason_not_ready
  {
    size_t item_size = sizeof(ros_message.reason_not_ready);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: reason_disengage_str
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.reason_disengage_str.size() + 1);
  // Member: reason_not_ready_str
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.reason_not_ready_str.size() + 1);
  // Member: btn_enable
  {
    size_t item_size = sizeof(ros_message.btn_enable);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: btn_disable
  {
    size_t item_size = sizeof(ros_message.btn_disable);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: override
  {
    size_t item_size = sizeof(ros_message.override);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: ready
  {
    size_t item_size = sizeof(ros_message.ready);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: enabled
  {
    size_t item_size = sizeof(ros_message.enabled);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: fault
  {
    size_t item_size = sizeof(ros_message.fault);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: bad_crc
  {
    size_t item_size = sizeof(ros_message.bad_crc);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: bad_rc
  {
    size_t item_size = sizeof(ros_message.bad_rc);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
max_serialized_size_SystemReport(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: header
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        std_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Header(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: inhibit
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: validate_cmd_crc_rc
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: system_sync_mode
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        ds_dbw_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_SystemSyncMode(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: state
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        ds_dbw_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_SystemState(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: reason_disengage
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: reason_not_ready
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: reason_disengage_str
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: reason_not_ready_str
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: btn_enable
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: btn_disable
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: override
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: ready
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: enabled
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: fault
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: bad_crc
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: bad_rc
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = ds_dbw_msgs::msg::SystemReport;
    is_plain =
      (
      offsetof(DataType, bad_rc) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _SystemReport__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const ds_dbw_msgs::msg::SystemReport *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _SystemReport__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<ds_dbw_msgs::msg::SystemReport *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _SystemReport__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const ds_dbw_msgs::msg::SystemReport *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _SystemReport__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_SystemReport(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _SystemReport__callbacks = {
  "ds_dbw_msgs::msg",
  "SystemReport",
  _SystemReport__cdr_serialize,
  _SystemReport__cdr_deserialize,
  _SystemReport__get_serialized_size,
  _SystemReport__max_serialized_size
};

static rosidl_message_type_support_t _SystemReport__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_SystemReport__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace ds_dbw_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_ds_dbw_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<ds_dbw_msgs::msg::SystemReport>()
{
  return &ds_dbw_msgs::msg::typesupport_fastrtps_cpp::_SystemReport__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, ds_dbw_msgs, msg, SystemReport)() {
  return &ds_dbw_msgs::msg::typesupport_fastrtps_cpp::_SystemReport__handle;
}

#ifdef __cplusplus
}
#endif
