// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from ds_dbw_msgs:msg/UlcReport.idl
// generated code does not contain a copyright notice
#include "ds_dbw_msgs/msg/detail/ulc_report__rosidl_typesupport_fastrtps_cpp.hpp"
#include "ds_dbw_msgs/msg/detail/ulc_report__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace std_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const std_msgs::msg::Header &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  std_msgs::msg::Header &);
size_t get_serialized_size(
  const std_msgs::msg::Header &,
  size_t current_alignment);
size_t
max_serialized_size_Header(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace std_msgs


namespace ds_dbw_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
cdr_serialize(
  const ds_dbw_msgs::msg::UlcReport & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.header,
    cdr);
  // Member: cmd_type
  cdr << ros_message.cmd_type;
  // Member: vel_ref
  cdr << ros_message.vel_ref;
  // Member: vel_meas
  cdr << ros_message.vel_meas;
  // Member: accel_ref
  cdr << ros_message.accel_ref;
  // Member: accel_meas
  cdr << ros_message.accel_meas;
  // Member: coast_decel
  cdr << (ros_message.coast_decel ? true : false);
  // Member: ready
  cdr << (ros_message.ready ? true : false);
  // Member: enabled
  cdr << (ros_message.enabled ? true : false);
  // Member: override_active
  cdr << (ros_message.override_active ? true : false);
  // Member: override_latched
  cdr << (ros_message.override_latched ? true : false);
  // Member: preempted
  cdr << (ros_message.preempted ? true : false);
  // Member: timeout
  cdr << (ros_message.timeout ? true : false);
  // Member: bad_crc
  cdr << (ros_message.bad_crc ? true : false);
  // Member: bad_rc
  cdr << (ros_message.bad_rc ? true : false);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  ds_dbw_msgs::msg::UlcReport & ros_message)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.header);

  // Member: cmd_type
  cdr >> ros_message.cmd_type;

  // Member: vel_ref
  cdr >> ros_message.vel_ref;

  // Member: vel_meas
  cdr >> ros_message.vel_meas;

  // Member: accel_ref
  cdr >> ros_message.accel_ref;

  // Member: accel_meas
  cdr >> ros_message.accel_meas;

  // Member: coast_decel
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.coast_decel = tmp ? true : false;
  }

  // Member: ready
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.ready = tmp ? true : false;
  }

  // Member: enabled
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.enabled = tmp ? true : false;
  }

  // Member: override_active
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.override_active = tmp ? true : false;
  }

  // Member: override_latched
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.override_latched = tmp ? true : false;
  }

  // Member: preempted
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.preempted = tmp ? true : false;
  }

  // Member: timeout
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.timeout = tmp ? true : false;
  }

  // Member: bad_crc
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.bad_crc = tmp ? true : false;
  }

  // Member: bad_rc
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.bad_rc = tmp ? true : false;
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
get_serialized_size(
  const ds_dbw_msgs::msg::UlcReport & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: header

  current_alignment +=
    std_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.header, current_alignment);
  // Member: cmd_type
  {
    size_t item_size = sizeof(ros_message.cmd_type);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: vel_ref
  {
    size_t item_size = sizeof(ros_message.vel_ref);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: vel_meas
  {
    size_t item_size = sizeof(ros_message.vel_meas);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: accel_ref
  {
    size_t item_size = sizeof(ros_message.accel_ref);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: accel_meas
  {
    size_t item_size = sizeof(ros_message.accel_meas);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: coast_decel
  {
    size_t item_size = sizeof(ros_message.coast_decel);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: ready
  {
    size_t item_size = sizeof(ros_message.ready);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: enabled
  {
    size_t item_size = sizeof(ros_message.enabled);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: override_active
  {
    size_t item_size = sizeof(ros_message.override_active);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: override_latched
  {
    size_t item_size = sizeof(ros_message.override_latched);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: preempted
  {
    size_t item_size = sizeof(ros_message.preempted);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: timeout
  {
    size_t item_size = sizeof(ros_message.timeout);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: bad_crc
  {
    size_t item_size = sizeof(ros_message.bad_crc);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: bad_rc
  {
    size_t item_size = sizeof(ros_message.bad_rc);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_ds_dbw_msgs
max_serialized_size_UlcReport(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: header
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        std_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Header(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: cmd_type
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: vel_ref
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: vel_meas
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: accel_ref
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: accel_meas
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: coast_decel
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: ready
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: enabled
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: override_active
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: override_latched
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: preempted
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: timeout
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: bad_crc
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: bad_rc
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = ds_dbw_msgs::msg::UlcReport;
    is_plain =
      (
      offsetof(DataType, bad_rc) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _UlcReport__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const ds_dbw_msgs::msg::UlcReport *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _UlcReport__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<ds_dbw_msgs::msg::UlcReport *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _UlcReport__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const ds_dbw_msgs::msg::UlcReport *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _UlcReport__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_UlcReport(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _UlcReport__callbacks = {
  "ds_dbw_msgs::msg",
  "UlcReport",
  _UlcReport__cdr_serialize,
  _UlcReport__cdr_deserialize,
  _UlcReport__get_serialized_size,
  _UlcReport__max_serialized_size
};

static rosidl_message_type_support_t _UlcReport__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_UlcReport__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace ds_dbw_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_ds_dbw_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<ds_dbw_msgs::msg::UlcReport>()
{
  return &ds_dbw_msgs::msg::typesupport_fastrtps_cpp::_UlcReport__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, ds_dbw_msgs, msg, UlcReport)() {
  return &ds_dbw_msgs::msg::typesupport_fastrtps_cpp::_UlcReport__handle;
}

#ifdef __cplusplus
}
#endif
